load("PolarData_Bins234.Rdata")
Dist.by.Transect=read.csv("Statistics_OnEffort_ByEvent.csv")
ObsInfo=read.csv("ObsInfo.csv")
ObsInfo[,"Observer"]=as.character(ObsInfo[,"Observer"])
ObsInfo[,"Side"]=as.character(ObsInfo[,"Side"])
BinInfo=read.csv("Scale.csv")
n.bins=3

######
Dat=Dat[Dat[,"Transect"]<20,]  #limit to double observer data
Dat[,"Transect"]=1
ID=Dat[,"Observer"]
Dat[,"Observer"]=as.factor(as.numeric(as.character(Dat[,"Pos"]))+1)
#Dat[,"Pos"]=ID
Dat=Dat[,-which(colnames(Dat)%in%c("Pos","Alt.500"))]
#cur.colnames=colnames(Dat)
#cur.colnames[7]="ID"
#colnames(Dat)=cur.colnames

tot.width.500=sum(BinInfo[which(BinInfo[,"BIN"]>0 & BinInfo[,"BIN"]<5 & BinInfo[,"Altitude_ft"]==500),"BinWidth_m"])
tot.width.400=sum(BinInfo[which(BinInfo[,"BIN"]>0 & BinInfo[,"BIN"]<5 & BinInfo[,"Altitude_ft"]==400),"BinWidth_m"])
n.transects=max(Dat[,"Transect"])

####
#S=n.transects/2
S=n.transects
Area.hab=1

Hab.cov=NA
#colnames(Hab.cov)="Int"

Event.ind=c(1:21)
Event.ind=Event.ind[-c(6,9)]
Observers=matrix(c(1,2),2,n.transects)
####
#Observers[1,20:38]=ObsInfo[which(ObsInfo[,"Event"]%in%Event.ind & ObsInfo[,"Side"]=='L'),"Observer"]

#convert 'Obs' to numeric 
Dat[,"Obs"]=as.numeric(Dat[,"Obs"])
if(n.bins==3)Dat[,"Distance"]=Dat[,"Distance"]-1  # for three bins, make bins 2,3,4, into 1,2,3
Obs.cov=NULL
#convert 'Observers' to numeric
#Obs.id=c("MDB","JFT","MFC","MA","KMY","EEM")
#Obs.numeric=rep(0,nrow(Dat))
#for(i in 1:nrow(Dat))Obs.numeric[i]=which(Obs.id==Dat[i,"Observer"])
#Dat[,"Observer"]=Obs.numeric

n.obs.cov=0
Adj=NA #no spatial model assumed
misID.mat=matrix(0,4,5)  # misID matrix 
misID.mat[1,]=c(1,2,3,4,-1)  # positive numbers specify a model, 0 denotes impossible, -1 denotes obtain by subtraction
misID.mat[2,]=c(-1,5,6,7,-1)
misID.mat[3,]=c(-1,-1,8,9,-1)
misID.mat[4,]=c(-1,-1,-1,10,-1)
misID.models=sapply(rep('~1',max(misID.mat)),"as.formula")
MisID=vector("list",max(misID.mat))
for(i in 1:max(misID.mat))MisID[[i]]=1
Self.ind=diag(misID.mat)
for(i in 1:length(Self.ind))MisID[[Self.ind[i]]]=2 #parameters for getting it right
misID.symm=TRUE
####
#Mapping=c(c(1:S),c(1:S))
Mapping=c(1:S)
Area.trans=rep(1,n.transects)
#Dat=Dat[,-8] uncomment if not modeling species effect
n.bins=length(unique(Dat[,"Distance"]))
#Bin.length=c(16.9337,42.996,65.873,154.751,356.47)
Bin.length=c(42.996,65.873,123.801)
Bin.length=Bin.length/mean(Bin.length)

#Hab.formula=~Cov1
Hab.formula=c(~1,~1,~1,~1)
detect=TRUE
#Det.formula=~Observer+Distance+Group+Species+Pos+Alt.500
Det.formula=~Distance+Observer
n.species=nrow(misID.mat)
Cov.prior.parms=array(0,dim=c(n.species,2,1))
Cov.prior.parms[1,,1]=c(mean(Dat[which(Dat[,"Species"]==1)+.1,"Group"])-1,1)
Cov.prior.parms[2,,1]=c(mean(Dat[which(Dat[,"Species"]==2)+.1,"Group"])-1,1)
Cov.prior.parms[3,,1]=c(mean(Dat[which(Dat[,"Species"]==3)+.1,"Group"])-1,1)
Cov.prior.parms[4,,1]=c(mean(Dat[which(Dat[,"Species"]==4)+.1,"Group"])-1,1)
Cov.prior.fixed=matrix(0,n.species,dim(Cov.prior.parms)[3])
Cov.prior.pdf=Cov.prior.fixed
Cov.prior.pdf[,1]=c("pois1","pois1","pois1","pois1")
Cov.prior.n=matrix(2,n.species,1)

point.ind=FALSE
last.ind=FALSE
spat.ind=TRUE #dont' include spatial dependence unless there really is spatial structure!
cor.const=FALSE
###
fix.tau.nu=TRUE
srr=FALSE
srr.tol=0.2
misID=TRUE
grps=TRUE

M=matrix(0,n.species,n.transects)

#start M at 12 times the level observed, with a minimum of 50 for each species-transect combo
for(isp in 1:n.species){
  for(itrans in 1:n.transects){
    M[isp,itrans]=length(which(Dat[,"Species"]==isp & Dat[,"Transect"]==itrans))*8+50
  }
}

#Control=list(iter=100000,burnin=20000,thin=10,MH.cor=0.2,MH.nu=c(.01,.01),MH.misID=matrix(0.1,4,9),RJ.N=matrix(rep(5,S*n.species),n.species,S),adapt=1000)
Control=list(iter=520000,burnin=20000,thin=100,MH.cor=0.2,MH.nu=matrix(.4,n.species,S),MH.beta=c(.2),MH.misID=matrix(0.4,10,1),RJ.N=matrix(rep(10,n.transects*n.species),n.species,n.transects),adapt=400,iter.fix.N=1000)
hab=matrix(log(20),n.species,1) #just an intercept
####
#det=c(2.5,rep(0,14))  #start detection probability relatively high
det=c(2.5,rep(0,3))
Inits=list(hab=hab,tau.nu=rep(500,n.species),MisID=MisID,det=det,cor=-.3) #chain1
misID.mu=vector("list",max(misID.mat))
misID.sd=misID.mu
for(i in 1:max(misID.mat)){
  misID.mu[[i]]=0
  misID.sd[[i]]=1.75
}
misID.mu[[3]]=-3
Prior.pars=list(a.eta=1,b.eta=.01,a.nu=1,b.nu=.01,beta.tau=0.1,misID.mu=misID.mu,misID.sd=misID.sd) #(1,.01) prior makes it closer to a uniform distribution near the origin
###
adapt=TRUE

#set.seed(8327329)   #chain1
set.seed(8327330)   #chain2
library(hierarchicalDS)
#Out=hierarchical_DS(Dat=Dat,Adj=Adj,Area.hab=Area.hab,Mapping=Mapping,Area.trans=Area.trans,Observers=Observers,Bin.length=Bin.length,Hab.cov=Hab.cov,Obs.cov=Obs.cov,n.obs.cov=n.obs.cov,Hab.formula=Hab.formula,detect=detect,Det.formula=Det.formula,Cov.prior.pdf=Cov.prior.pdf,Cov.prior.parms=Cov.prior.parms,Cov.prior.fixed=Cov.prior.fixed,Cov.prior.n=Cov.prior.n,pol.eff=NULL,point.ind=TRUE,spat.ind=spat.ind,fix.tau.nu=fix.tau.nu,srr=srr,srr.tol=srr.tol,misID=misID,Inits=Inits,grps=grps,M=M,Control=Control,Levels=Levels,adapt=TRUE,Prior.pars=Prior.pars,misID.mat=misID.mat,misID.models=misID.models,misID.symm=misID.symm)

Out=hierarchical_DS(Dat=Dat,Adj=Adj,Area.hab=Area.hab,Mapping=Mapping,Area.trans=Area.trans,Observers=Observers,Bin.length=Bin.length,Hab.cov=Hab.cov,Obs.cov=Obs.cov,n.obs.cov=n.obs.cov,Hab.pois.formula=Hab.formula,detect=detect,Det.formula=Det.formula,Cov.prior.pdf=Cov.prior.pdf,Cov.prior.parms=Cov.prior.parms,Cov.prior.fixed=Cov.prior.fixed,Cov.prior.n=Cov.prior.n,pol.eff=NULL,point.ind=point.ind,spat.ind=spat.ind,last.ind=last.ind,cor.const=cor.const,fix.tau.nu=fix.tau.nu,srr=srr,srr.tol=srr.tol,misID=misID,Inits=Inits,grps=grps,M=M,Control=Control,adapt=adapt,Prior.pars=Prior.pars,misID.mat=misID.mat,misID.models=misID.models,misID.symm=misID.symm)

post_loss(Out,burnin=0)
save(Out,file="pooled_analysis_rbprior.Rdat")

#pdf("pooled_diagnostics.pdf")
#plot(Out$MCMC)
#dev.off()


